MCP endpoint for Cloud Billing API

A [Model Context Protocol (MCP) server](https://modelcontextprotocol.io/docs/learn/server-concepts) acts as a proxy between an external service that provides context, data, or capabilities to a Large Language Model (LLM) or AI application. MCP servers connect AI applications to external systems such as databases and web services, translating their responses into a format that the AI application can understand.

### Server Setup


You must [enable MCP servers](https://docs.cloud.google.com/mcp/enable-disable-mcp-servers) and [set up authentication](https://docs.cloud.google.com/mcp/authenticate-mcp) before use. For more information about using Google and Google Cloud remote MCP servers, see [Google Cloud MCP servers overview](https://docs.cloud.google.com/mcp/overview).

### Server Endpoints

An MCP service endpoint is the network address and communication interface (usually a URL) of the MCP server that an AI application (the Host for the MCP client) uses to establish a secure, standardized connection. It is the point of contact for the LLM to request context, call a tool, or access a resource. Google MCP endpoints can be global or regional.

The Cloud Billing API MCP server has the following global MCP endpoint:

- https://cloudbilling.googleapis.com/mcp

## MCP Tools

An [MCP tool](https://modelcontextprotocol.io/legacy/concepts/tools) is a function or executable capability that an MCP server exposes to a LLM or AI application to perform an action in the real world.

### Tools

The cloudbilling.googleapis.com MCP server has the following tools:

| MCP Tools ||
|---|---|
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_billing_account` | Retrieves a Cloud Billing account by its resource name. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_billing_accounts` | Lists all Cloud Billing accounts a user has access to. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/create_billing_account` | Creates a billing subaccount. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/move_billing_account` | Changes which parent organization a billing account belongs to. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_iam_policy` | Gets the access control policy for a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/set_iam_policy` | Sets the access control policy for a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/test_iam_permissions` | Tests the access control policy for a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_project_billing_info` | Retrieves the billing information for a project. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_project_billing_info` | Lists the billing information for all projects linked to a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_billing_account_prices` | Lists the billing account prices for a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_billing_account_price` | Gets the latest price for a specific SKU available to a Cloud Billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_prices` | Lists the latest consumption model prices for all SKUs. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_price` | Gets the latest consumption model price for a given SKU. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_billing_account_services` | Lists billing account services visible to a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_billing_account_service` | Gets a billing account service visible to a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_billing_account_sku_groups` | Lists SKU groups visible to a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_billing_account_sku_group` | Gets a SKU group visible to a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_billing_account_sku_group_skus` | Lists billing account visible SKUs that are contained by a billing account visible SKU group. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_billing_account_sku_group_sku` | Gets a billing account visible SKU that is part of a billing account visible SKU group. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_billing_account_skus` | Lists SKUs visible to a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_billing_account_sku` | Gets a SKU visible to a billing account. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_services` | Lists all publicly listed services. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_service` | Gets a publicly listed service. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_sku_groups` | Lists all publicly listed SKU groups. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_sku_group` | Gets a publicly listed SKU group. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_sku_group_skus` | Lists all publicly listed SKUs contained by a publicly listed SKU group. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_sku_group_sku` | Gets a publicly listed SKU that is part of a publicly listed SKU group. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/list_skus` | Lists all publicly listed SKUs. |
| `https://docs.cloud.google.com/billing/docs/reference/mcp/tools_list/get_sku` | Gets a publicly listed SKU. |

### Get MCP tool specifications


To get the MCP tool specifications for all tools in an MCP server, use the `tools/list` method. The following example demonstrates how to use `curl` to list all tools and their specifications currently available within the MCP server.

| Curl Request |
|---|
| ```bash curl --location 'https://cloudbilling.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/list", "jsonrpc": "2.0", "id": 1 }' ``` |